Unit AVZ7C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTAV10_p;

function AVZ7C(N :Integer; var CX :Array of Complex; INCX :Integer;
                var IERR :Integer): Integer;

implementation

function AVZ7C(N :Integer; var CX :Array of Complex; INCX :Integer;
                var IERR :Integer): Integer;
var
I,INCX1,IX :Integer;
CMAX :Real;
ARG :Complex;
label
_10,_20,_30,_40,_50,_60;
{  -  FORTRAN }
function C1ABS(ARG: Complex): Real;
begin
Result := Abs(Creal(ARG)) + Abs(Aimag(ARG));
end;
{   - }
begin
{ Result -    AVZ7C  FORTRANe }
if ( N  <=  0 ) 
 then goto _50;
IERR  := 0;
Result := Trunc( 1 );
if ( N  =  1 ) 
 then goto _60;
IX  := 1;
CMAX  := C1ABS(CX[0]);
INCX1  := Abs(INCX);
if ( INCX1  =  1 ) 
 then goto _30;
IX  := IX + INCX1;
for I:=2 to N do
 begin
  if ( C1ABS(CX[IX-1]) <=  CMAX ) 
   then goto _10;
  Result := Trunc( I );
  CMAX  := C1ABS(CX[IX-1]);
_10:
  IX  := IX + INCX1;
_20:
 end;
goto _60;
_30:
CMAX  := C1ABS(CX[0]);
for I:=2 to N do
 begin
  if ( C1ABS(CX[I-1]) <=  CMAX ) 
   then goto _40;
  Result := Trunc( I );
  CMAX  := C1ABS(CX[I-1]);
_40:
 end;
goto _60;
_50:
IERR  := 65;
UTAV10(IERR,3);
Result := Trunc( 0 );
_60:
exit;
end;

end.
